ext WaitTimer_

tempo equ 220/2

BeepPort equ 35h
BeepBit equ 08h

dseg
time:
    defw 0
pMelody:
    defw 0
lenCount:
    defb 0

cseg
Tone: public Tone
;   dx : cycle
;   bx : length
    push ax | push cx
        do
            in al,BeepPort
            and al,not BeepBit
            out BeepPort,al
            mov cx,dx
            do | wloop

            in al,BeepPort
            or al,BeepBit
            out BeepPort,al
            mov cx,dx
            do | wloop

            dec bx
        while nz | wend
    pop cx| pop ax
ret


Rest:
;   dx : cycle
;   bx : length
    push ax | push cx
        do
            in al,BeepPort
            or al,BeepBit
            out BeepPort,al
            mov cx,dx
            do | wloop

            in al,BeepPort
            or al,BeepBit
            out BeepPort,al
            mov cx,dx
            do | wloop
            dec bx
        while nz | wend
    pop cx| pop ax
ret


Melody: public Melody
;   bx
    push ax | push bx | push cx | push dx
        cli
            do
                mov cl,[si] | inc si
                or cl,cl
            while ne
                mov al,[si] | inc si
                or al,al
                if nz
                    dec al
                    shl al,1 | shl al,1
                    xor ah,ah
                    add ax,cycles
                    mov bx,ax
                    mov dx,[bx] | add bx,2
                    mov al,[bx]
                    mul cl
                    mov bx,ax
                    call Tone
                else
                    mov dx,[cycles]
                    mov al,[cycles+2]
                    mul cl
                    mov bx,ax
                    call Rest
                endif
            wend
        sti
    pop dx | pop cx | pop bx | pop ax
ret


loose_notes:
    defb 2,C4, 2,0, 0
Sound_Loose_: public Sound_Loose_
    push si
        mov si,loose_notes
        call Melody
    pop si
ret


Sound_Hit_: public Sound_Hit_
    push bx | push dx
        mov dx,1000
        mov bx,3
        do
            push bx | push dx
                call Tone
            pop dx | pop bx
            sub dx,10
            cmp dx,500
        while nb | wend
    pop dx | pop bx
ret


Sound_Miss_: public Sound_Miss_
    push bx | push dx
        mov dx,500
        mov bx,3
        do
            push bx | push dx
                call Tone
            pop dx | pop bx
            add dx,10
            cmp dx,1000
        while b | wend
    pop dx | pop bx
ret


Sound_Get_: public Sound_Get_
Sound_Beep_: public Sound_Beep_
    push ax
        in al,BeepPort
        and al,not BeepBit
        out BeepPort,al

        mov al,6
        call WaitTimer_

        in al,BeepPort
        or al,BeepBit
        out BeepPort,al

        mov al,2
        call WaitTimer_
    pop ax
ret


start_notes: defb 3,C4, 3,G4, 3,E4, 3,G4, 12,C5, 0
Sound_Start_: public Sound_Start_
    mov si,start_notes
jmp Melody

clear_notes: defb 3,C4, 3,E4, 3,G4, 3,D4, 3,F4, 3,A4, 3,E4, 3,G4, 3,B4, 9,C5,0
Sound_Clear_: public Sound_Clear_
    mov si,clear_notes
jmp Melody

over_notes: defb 3,C5, 3,G4, 3,E4, 3,C5,  3,B4, 3,G4, 3,E4, 3,B4,  6,A4, 6,B4,  12,C5, 0
Sound_GameOver_: public Sound_GameOver_
    mov si,over_notes
jmp Melody


C4 equ 1
C4S equ 2
D4 equ 3
D4S equ 4
E4 equ 5
F4 equ 6
F4S equ 7
G4 equ 8
G4S equ 9
A4 equ 10
A4S equ 11
B4 equ 12
C5 equ 13
C5S equ 14
D5 equ 15
D5S equ 16
E5 equ 17
F5 equ 18

N8 equ 6
N8P equ N8*3/2
N4 equ N8*2
N4P equ N4*3/2
N2 equ N4*2
N2P equ N2*3/2
N1 equ N2*2

cycles:
defw 1272,980/tempo  ; C4
defw 1200,1039/tempo  ; C#4
defw 1133,1101/tempo  ; D4
defw 1069,1166/tempo  ; D#4
defw 1009,1236/tempo  ; E4
defw 952,1309/tempo  ; F4
defw 898,1388/tempo  ; F#4
defw 848,1470/tempo  ; G4
defw 800,1558/tempo  ; G#4
defw 755,1650/tempo  ; A4
defw 713,1747/tempo  ; A#4
defw 673,1851/tempo  ; B4
defw 635,1961/tempo  ; C5
